> ## Documentation Index
> Fetch the complete documentation index at: https://arc.sdjz.wiki/llms.txt
> Use this file to discover all available pages before exploring further.

# Wait for config generation change



## OpenAPI

````yaml openapi/arc-gateway-control-plane.openapi.yaml get /v1/config/longpoll
openapi: 3.1.0
info:
  title: Arc Gateway Control Plane API
  version: 1.0.0
  license:
    name: Apache-2.0
    identifier: Apache-2.0
  description: >
    OpenAPI for Arc Gateway control-plane HTTP endpoints implemented in
    `crates/arc-gateway/src/control.rs`.


    Authentication behavior:

    - If `control_plane.auth_token` is set, send `Authorization: Bearer
    <token>`.

    - If `control_plane.auth_token` is not set, only loopback clients are
    accepted.
servers:
  - url: http://127.0.0.1:22100
security:
  - bearerAuth: []
  - {}
tags:
  - name: status
    description: Node status and generation endpoints.
  - name: config
    description: Config fetch, long-poll, validation, and local apply endpoints.
  - name: cluster
    description: Cluster-level config push and circuit snapshot endpoints.
  - name: gossip
    description: Gossip membership, stats, and lifecycle endpoints.
  - name: xdp
    description: XDP status and map management endpoints.
paths:
  /v1/config/longpoll:
    get:
      tags:
        - config
      summary: Wait for config generation change
      operationId: longPollConfig
      parameters:
        - name: since
          in: query
          required: false
          description: Last seen generation.
          schema:
            type: integer
            format: int64
            minimum: 0
        - name: timeout_ms
          in: query
          required: false
          description: Wait timeout in milliseconds.
          schema:
            type: integer
            format: int64
            minimum: 1
            maximum: 120000
        - name: If-None-Match
          in: header
          required: false
          description: Alternative way to pass `since`.
          schema:
            type: string
      responses:
        '200':
          description: Config changed and new config returned
          headers:
            ETag:
              description: Quoted generation value.
              schema:
                type: string
            Cache-Control:
              schema:
                type: string
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ArcConfigDocument'
        '304':
          description: Timeout with no config change
        '401':
          $ref: '#/components/responses/Unauthorized'
        '500':
          $ref: '#/components/responses/InternalError'
components:
  schemas:
    ArcConfigDocument:
      type: object
      description: Raw Arc config JSON document.
      additionalProperties: true
    ErrorResponse:
      type: object
      required:
        - error
      properties:
        error:
          type: string
  responses:
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
          example:
            error: unauthorized
    InternalError:
      description: Internal error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: opaque

````